<template>
  <transition name="showHeader">
    <div v-if="visible" class="header-animat">
      <a-layout-header
        v-if="visible"
        :class="[
          fixedHeader && 'ant-header-fixedHeader',
          sidebarOpened ? 'ant-header-side-opened' : 'ant-header-side-closed'
        ]"
        :style="{ padding: '0', background: '#fff', boxShadow: '0 1px 4px rgba(0, 21, 41, 0.08)' }"
      >
        <div
          v-if="mode === 'sidemenu'"
          class="header"
          style="display: flex; align-items: center;"
        >
          <div style="display: flex">
            <div>
              <a-icon
                v-if="device === 'mobile'"
                :type="collapsed ? 'menu-fold' : 'menu-unfold'"
                @click="toggle"
                class="trigger"
              />
              <a-icon
                v-else
                :type="collapsed ? 'menu-unfold' : 'menu-fold'"
                @click="toggle"
                class="trigger"
              />
            </div>
          </div>
          <span style="flex: 1; text-align: left;" />
          <div style="display: flex;">
            <user-menu :device="device" />
          </div>
        </div>
        <div v-else :class="['top-nav-header-index', theme]">
          <div class="header-index-wide">
            <div class="header-index-left">
              <logo :show-title="device !== 'mobile'" class="top-nav-header" />
              <s-menu
                v-if="device !== 'mobile'"
                :menu="menus"
                :theme="theme"
                mode="horizontal"
              />
              <a-icon
                v-else
                :type="collapsed ? 'menu-fold' : 'menu-unfold'"
                @click="toggle"
                class="trigger"
              />
            </div>
            <user-menu class="header-index-right" />
          </div>
        </div>
      </a-layout-header>
    </div>
  </transition>
</template>

<script>
import { mapGetters } from 'vuex'
import { mixin } from '@/utils/mixin'
import UserMenu from '../tools/UserMenu'
import SMenu from '../Menu/'
import Logo from '../tools/Logo'

export default {
  name: 'GlobalHeader',
  components: {
    // eslint-disable-next-line vue/no-unused-components
    UserMenu,
    SMenu,
    Logo
  },
  mixins: [mixin],
  props: {
    mode: {
      type: String,
      // sidemenu, topmenu
      default: 'sidemenu'
    },
    menus: {
      type: Array,
      required: true
    },
    theme: {
      type: String,
      required: false,
      default: 'dark'
    },
    collapsed: {
      type: Boolean,
      required: false,
      default: false
    },
    device: {
      type: String,
      required: false,
      default: 'desktop'
    }
  },
  data () {
    return {
      visible: true,
      oldScrollTop: 0
    }
  },
  computed: {
    ...mapGetters('auth', ['isAdmin', 'userInfo'])
  },
  mounted () {
    document.body.addEventListener('scroll', this.handleScroll, {
      passive: true
    })
  },
  beforeDestroy () {
    document.body.removeEventListener('scroll', this.handleScroll, true)
  },
  methods: {
    handleScroll () {
      if (!this.autoHideHeader) {
        return
      }

      const scrollTop =
        document.body.scrollTop + document.documentElement.scrollTop
      if (!this.ticking) {
        this.ticking = true
        requestAnimationFrame(() => {
          if (this.oldScrollTop > scrollTop) {
            this.visible = true
          } else if (scrollTop > 300 && this.visible) {
            this.visible = false
          } else if (scrollTop < 300 && !this.visible) {
            this.visible = true
          }
          this.oldScrollTop = scrollTop
          this.ticking = false
        })
      }
    },
    toggle () {
      this.$emit('toggle')
    }
  }
}
</script>

<style lang="less">
.header-animat {
  position: relative;
  z-index: 2;
}
.showHeader-enter-active {
  transition: all 0.25s ease;
}
.showHeader-leave-active {
  transition: all 0.5s ease;
}
.showHeader-enter,
.showHeader-leave-to {
  opacity: 0;
}
</style>
